## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# StylesheetHandler Class Reference

This class processes a stylesheet via SAX events, and inits the given stylesheet. More...

`#include <StylesheetHandler.hpp>`

Inheritance diagram for StylesheetHandler:

[legend]
Collaboration diagram for StylesheetHandler:

[legend]
List of all members.

## Public Types

- typedef XalanVector<ElemTemplateElement*> ElemTemplateStackType
- typedef XalanVector<ElemTemplateElement*> ElemTextLiteralStackType
- typedef XalanVector<bool> BoolStackType
- typedef XalanSet<XalanQNameByReference> QNameSetType
- typedef XalanVector<QNameSetType,
  ConstructWithMemoryManagerTraits<
  QNameSetType> > QNameSetVectorType

## Public Methods

- StylesheetHandler (Stylesheet &stylesheetTree, StylesheetConstructionContext &constructionContext)
    Construct a StylesheetHandler ... More...
- MemoryManagerType& getMemoryManager ()
- virtual ~StylesheetHandler ()
- virtual void characters (const XMLCh *const chars, const unsigned int length)
    Receive notification of character data. More...
- virtual void charactersRaw (const XMLCh *const chars, const unsigned int length)
    Receive notification of character data. More...
- virtual void cdata (const XMLCh *const ch, const unsigned int length)
    Receive notification of cdata. More...
- virtual void ignorableWhitespace (const XMLCh *const chars, const unsigned int length)
    Receive notification of ignorable whitespace in element content. More...
- virtual void processingInstruction (const XMLCh *const target, const XMLCh *const data)
    Receive notification of a processing instruction. More...
- virtual void comment (const XMLCh *const data)
    Called when a Comment is to be constructed. More...
- virtual void entityReference (const XMLCh *const data)
    Receive notification of a entityReference. More...
- virtual void setDocumentLocator (const LocatorType *const locator)
    Receive an object for locating the origin of SAX document events. More...
- virtual void startDocument ()
    Receive notification of the beginning of a document. More...
- virtual void endDocument ()
    Receive notification of the end of a document. More...
- virtual void startElement (const XMLCh *const name, AttributeListType &attrs)
    Receive notification of the beginning of an element. More...
- virtual void endElement (const XMLCh *const name)
    Receive notification of the end of an element. More...
- virtual void resetDocument ()
    This method allows the user installed Document Handler to 'reset' itself, freeing all the memory resources. More...

## Static Public Methods

- void initialize (MemoryManagerType &theManager)
    Perform static initialization. More...
- void terminate ()
    Perform static shut down. More...

## Protected Methods

- bool isAttrOK (const XalanDOMChar *attrName, const AttributeListType &atts, int which)
    See if this is a xmlns attribute, and, if so, process it. More...
- bool processSpaceAttr (const XalanDOMChar *elementName, const XalanDOMChar *aname, const AttributeListType &atts, int which, const LocatorType *locator, bool &fPreserve)
    Tell whether or not this is a xml:space attribute and, if so, process it. More...
- bool processSpaceAttr (const XalanDOMChar *elementName, const AttributeListType &atts, const LocatorType *locator, bool &fPreserve)
    Tell whether or not this is a xml:space attribute and, if so, process it. More...
- void processImport (const XalanDOMChar *name, const AttributeListType &atts, const LocatorType *locator)
    Process xsl:import. More...
- void processInclude (const XalanDOMChar *name, const AttributeListType &atts, const LocatorType *locator)
    Process xsl:include. More...
- void doCleanup ()

## Detailed Description

This class processes a stylesheet via SAX events, and inits the given stylesheet.

If you need to alter the code in here, it is not for the faint-of-heart, due to the state tracking that has to be done due to the SAX event model.

## Member Typedef Documentation

typedef XalanVector< bool > StylesheetHandler::BoolStackType<bool>

typedef XalanVector< ElemTemplateElement *> StylesheetHandler::ElemTemplateStackType<ElemTemplateElement*>

typedef XalanVector< ElemTemplateElement *> StylesheetHandler::ElemTextLiteralStackType<ElemTemplateElement*>

typedef XalanSet< XalanQNameByReference > StylesheetHandler::QNameSetType<XalanQNameByReference>

typedef XalanVector< QNameSetType, ConstructWithMemoryManagerTraits< QNameSetType > > StylesheetHandler::QNameSetVectorType<QNameSetType, ConstructWithMemoryManagerTraits<QNameSetType> >

## Constructor & Destructor Documentation

StylesheetHandler::StylesheetHandler ( | Stylesheet & stylesheetTree,
| StylesheetConstructionContext & constructionContext )

| Construct a StylesheetHandler ... it will add the DOM nodes to the document fragment.

StylesheetHandler::~StylesheetHandler ( | )`[virtual]`

## Member Function Documentation

void StylesheetHandler::cdata ( | const XMLCh *const ch,
| const unsigned int length )`[virtual]`

  | Receive notification of cdata. The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information. The application must not attempt to read from the array outside of the specified range. Note that some parsers will report whitespace using the ignorableWhitespace() method rather than this one (validating parsers must do so). Parameters:
  ch | pointer to characters from the XML document
  start | start position in the array
  length | number of characters to read from the array
  Exceptions:
  SAXException |
See also: ignorableWhitespace

void StylesheetHandler::characters ( | const XMLCh *const chars,
| const unsigned int length )`[virtual]`

  | Receive notification of character data. The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information. The application must not attempt to read from the array outside of the specified range. Note that some parsers will report whitespace using the ignorableWhitespace() method rather than this one (validating parsers must do so). Parameters:
  chars | pointer to characters from the XML document
  length | number of characters to read from the array
  Exceptions:
  SAXException |
See also: ignorableWhitespace , org.xml.sax.Locator

void StylesheetHandler::charactersRaw ( | const XMLCh *const chars,
| const unsigned int length )`[virtual]`

  | Receive notification of character data. If available, when the disable-output-escaping attribute is used, output raw text without escaping. Parameters:
  ch | pointer to characters from the XML document
  start | start position in the array
  length | number of characters to read from the array
  Exceptions:
  SAXException |

void StylesheetHandler::comment ( | const XMLCh *const data )`[virtual]`

  | Called when a Comment is to be constructed. Parameters:
  data | comment data
  Exceptions:
  SAXException |

void StylesheetHandler::doCleanup ( | )`[protected]`

void StylesheetHandler::endDocument ( | )`[virtual]`

  | Receive notification of the end of a document. The SAX parser will invoke this method only once, and it will be the last method invoked during the parse. The parser shall not invoke this method until it has either abandoned parsing (because of an unrecoverable error) or reached the end of input. Exceptions:
  SAXException |

void StylesheetHandler::endElement ( | const XMLCh *const name )`[virtual]`

  | Receive notification of the end of an element. The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding startElement() event for every endElement() event (even when the element is empty). If the element name has a namespace prefix, the prefix will still be attached to the name. Parameters:
  name | element type name
  Exceptions:
  SAXException |

void StylesheetHandler::entityReference ( | const XMLCh *const data )`[virtual]`

  | Receive notification of a entityReference. Parameters:
  data | pointer to characters from the XML document
  Exceptions:
  SAXException |

MemoryManagerType & StylesheetHandler::getMemoryManager ( | )

void StylesheetHandler::ignorableWhitespace ( | const XMLCh *const chars,
| const unsigned int length )`[virtual]`

  | Receive notification of ignorable whitespace in element content. Validating Parsers must use this method to report each chunk of ignorable whitespace (see the W3C XML 1.0 recommendation, section 2.10): non-validating parsers may also use this method if they are capable of parsing and using content models. SAX parsers may return all contiguous whitespace in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information. The application must not attempt to read from the array outside of the specified range. Parameters:
  chars | characters from the XML document
  start | start position in the array
  length | number of characters to read from the array
  Exceptions:
  SAXException |
See also: characters

void StylesheetHandler::initialize ( | MemoryManagerType & theManager )`[static]`

| Perform static initialization. See class XMLSupportInit.

bool StylesheetHandler::isAttrOK ( | const XalanDOMChar * attrName,
| const AttributeListType & atts,
| int which )`[protected]`

  | See if this is a xmlns attribute, and, if so, process it. Parameters:
  attrName | Qualified name of attribute.
  atts | The attribute list where the element comes from (not used at this time).
  which | The index into the attribute list (not used at this time).
Returns: True if this is a namespace name.

void StylesheetHandler::processImport ( | const XalanDOMChar * name,
| const AttributeListType & atts,
| const LocatorType * locator )`[protected]`

| Process xsl:import.

void StylesheetHandler::processInclude ( | const XalanDOMChar * name,
| const AttributeListType & atts,
| const LocatorType * locator )`[protected]`

| Process xsl:include.

bool StylesheetHandler::processSpaceAttr ( | const XalanDOMChar * elementName,
| const AttributeListType & atts,
| const LocatorType * locator,
| bool & fPreserve )`[protected]`

  | Tell whether or not this is a xml:space attribute and, if so, process it. Parameters:
  elementName | The name of the element that owns the attributes
  atts | The attribute list that owns the attribute.
  locator | A Locator instance for error reporting.
  fPreserve | set to true if an xml:space attribute value is "preserve"
Returns: True if this is a xml:space attribute.

bool StylesheetHandler::processSpaceAttr ( | const XalanDOMChar * elementName,
| const XalanDOMChar * aname,
| const AttributeListType & atts,
| int which,
| const LocatorType * locator,
| bool & fPreserve )`[protected]`

  | Tell whether or not this is a xml:space attribute and, if so, process it. Parameters:
  elementName | The name of the element that owns the attribute
  aname | The name of the attribute in question.
  atts | The attribute list that owns the attribute.
  which | The index of the attribute into the attribute list.
  locator | A Locator instance for error reporting.
  fPreserve | set to true if the attribute value is "preserve"
Returns: True if this is a xml:space attribute.

void StylesheetHandler::processingInstruction ( | const XMLCh *const target,
| const XMLCh *const data )`[virtual]`

  | Receive notification of a processing instruction. The Parser will invoke this method once for each processing instruction found: note that processing instructions may occur before or after the main document element. A SAX parser should never report an XML declaration (XML 1.0, section 2.8) or a text declaration (XML 1.0, section 4.3.1) using this method. Parameters:
  target | pointer to processing instruction target
  data | pointer to processing instruction data, or null if none was supplied
  Exceptions:
  SAXException |

void StylesheetHandler::resetDocument ( | )`[virtual]`

| This method allows the user installed Document Handler to 'reset' itself, freeing all the memory resources. The scanner calls this method before starting a new parse event.

void StylesheetHandler::setDocumentLocator ( | const LocatorType *const locator )`[virtual]`

  | Receive an object for locating the origin of SAX document events. SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the DocumentHandler interface. The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine. Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time. Parameters:
  locator | object that can return the location of any SAX document event.
See also: org.xml.sax.Locator

void StylesheetHandler::startDocument ( | )`[virtual]`

  | Receive notification of the beginning of a document. The SAX parser will invoke this method only once, before any other methods in this interface or in DTDHandler (except for setDocumentLocator). Exceptions:
  SAXException |

void StylesheetHandler::startElement ( | const XMLCh *const name,
| AttributeListType & attrs )`[virtual]`

  | Receive notification of the beginning of an element. The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding endElement() event for every startElement() event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement() event. If the element name has a namespace prefix, the prefix will still be attached. Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): IMPLIED attributes will be omitted. Parameters:
  name | element type name
  atts | attributes attached to the element, if any
  Exceptions:
  SAXException |
See also: endElement , org.xml.sax.AttributeList

void StylesheetHandler::terminate ( | )`[static]`

| Perform static shut down. See class XMLSupportInit.

## Friends And Related Function Documentation

class LastPoppedHolder`[friend]`

The documentation for this class was generated from the following file:

- StylesheetHandler.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.